#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <stdbool.h>
#include <unistd.h>
#include <pthread.h>
#include "thread.h"

typedef struct Data{
bool used;
int current_lap;
}Data;

/*--------datos----------*/
#define nro_hilos 4
static thread_t hilos[nro_hilos];
Data estado;
/*------------------------*/

void lock(Data *info){
info -> used = true;
}

void unlock(Data *info){
info -> used = false;
}

double fun(double x){
    double resultado = 5 * x*x*x*x + 2*x*x - 7*x + 1;
    return resultado;
}

void secant(){
    /*Se definen las variables para su uso en el codigo*/
    int iter = 0;
    int maxSteps = 15;
    double x1 = 0.5;
    double x2 = 1;
    double x3;
    double eps = 0.001;
    /*Se guarda el id del thread creado para su impresión en pantalla*/
    int id = pthread_self();
    printf("Se inicializó el thread %d\n", id);
    do{ x3 =(x1 * fun(x2) - x2 *fun(x1)) / (fun(x2) - fun(x1));
        x1=x2;
        x2=x3;
        iter++;
    } while ( fabs(fun(x3)) > eps&&iter <= maxSteps);
    /*Si la estructura no esta bloquedad, la bloquea y retorna el id del thread*/
    if (estado.used == false){
        lock(&estado);
        thread_exit(id);
    }
    else if (estado.used == true){
        thread_exit(-1);
    }
}

int main(int argc, char **argv){
    /*argv para que el usuario ingrese la cantidad de vueltas*/
    int max_vueltas = atoi(argv[1]);
    estado.used = false;
    estado.current_lap = 0;
    int fin[max_vueltas];
    for (int z = 0; z < max_vueltas; z++){
        /*Se crean los threads que se quieran*/
        for (int i = 0; i < nro_hilos; i++){
            thread_create(&hilos[i], &secant, i);
        }
        for (int i = 0; i < nro_hilos; i++){
            int ganador = thread_join(hilos[i]);
            if(ganador != -1){
                fin[z] = ganador;
                estado.current_lap = estado.current_lap + 1;
            }
        }
        unlock(&estado);
    }
    for (int i = 0; i < max_vueltas; i++){
        printf("Ganador Vuelta %d: %d\n", i + 1 ,fin[i]);
    }
}